import React from 'react';
import { FoundationFormErrors, FoundationFormProps, FoundationFormValueObject, FoundationFormValuesState } from './types';
import './FoundationForm.scss';
declare function noop(): void;
interface State<T extends FoundationFormValueObject> extends FoundationFormValuesState<T> {
    errors: FoundationFormErrors;
    isSubmitting: boolean;
}
export default class FoundationForm<T extends FoundationFormValueObject> extends React.Component<FoundationFormProps<T>, State<T>> {
    static defaultProps: {
        enableReinitialize: boolean;
        keepSuccessfulIsSubmitting: boolean;
        onReset: typeof noop;
        onSubmitError: typeof noop;
        onSubmitSuccess: typeof noop;
        resetOnSubmitSuccess: boolean;
        submit: () => Promise<{}>;
        wrapInForm: boolean;
    };
    static getDerivedStateFromProps<U extends FoundationFormValueObject>(nextProps: FoundationFormProps<U>, prevState: State<U>): Partial<State<U>>;
    constructor(props: FoundationFormProps<T>);
    addArrayElement: (name: string, initialValues: FoundationFormValueObject) => Promise<void>;
    change: (name: string, value: unknown) => Promise<void>;
    removeArrayElementAt: (name: string, index: number) => Promise<void>;
    removeAllArrayElements: (name: string) => Promise<void>;
    reset: () => void;
    submit: () => Promise<void>;
    render(): React.ReactNode;
}
export {};
